/*----- PROTECTED REGION ID(KeithleyMultimeters.h) ENABLED START -----*/
//=============================================================================
//
// file :        KeithleyMultimeters.h
//
// description : Include file for the KeithleyMultimeters class
//
// project :     Keithley multimeters device
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef KeithleyMultimeters_H
#define KeithleyMultimeters_H

#include <tango.h>
#include <string>
#include "KeithleyManager.hpp"


/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters.h

/**
 *  KeithleyMultimeters class description:
 *    Device to interface a Keithley multimeters 2701. <br>
 *    The Keithley is configured in Voltmeter <br>
 *    The ReadBufferedData command initiate a scan and <br>
 *    readback data stored in the Keithley buffer up to 450000 points. <br>
 *    nbPoins and nPLC attributes are INVALID in RUNNING state (while Keithley integrates).
 */

namespace KeithleyMultimeters_ns
{
/*----- PROTECTED REGION ID(KeithleyMultimeters::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::Additional Class Declarations

class KeithleyMultimeters : public Tango::Device_4Impl
{

/*----- PROTECTED REGION ID(KeithleyMultimeters::Data Members) ENABLED START -----*/

//	Add your own data members
public:



/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::Data Members

//	Device property data members
public:
	//	CommunicationLinkName:	Name of the device which handles the communication protocol
	string	communicationLinkName;
	//	SpecificConfiguration:	User Keithley configuration
	vector<string>	specificConfiguration;

//	Attribute data members
public:
	Tango::DevDouble	*attr_nPLC_read;
	Tango::DevString	*attr_triggerSource_read;
	Tango::DevULong		*attr_nbPoints_read;
	Tango::DevULong		*attr_nbBufferizedPoints_read;
	Tango::DevDouble	*attr_data_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	KeithleyMultimeters(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	KeithleyMultimeters(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	KeithleyMultimeters(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */	
	~KeithleyMultimeters() {delete_device();}


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : KeithleyMultimeters::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute nPLC related methods
 *	Description: Integration rate in line cycles in the range [0.002,50]
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_nPLC(Tango::Attribute &attr);
	virtual void write_nPLC(Tango::WAttribute &attr);
	virtual bool is_nPLC_allowed(Tango::AttReqType type);
/**
 *	Attribute triggerSource related methods
 *	Description: Select control source (IMMediate, TIMer, MANual, BUS or EXTernal).
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_triggerSource(Tango::Attribute &attr);
	virtual void write_triggerSource(Tango::WAttribute &attr);
	virtual bool is_triggerSource_allowed(Tango::AttReqType type);
/**
 *	Attribute nbPoints related methods
 *	Description: Acquisition number of points
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_nbPoints(Tango::Attribute &attr);
	virtual void write_nbPoints(Tango::WAttribute &attr);
	virtual bool is_nbPoints_allowed(Tango::AttReqType type);
/**
 *	Attribute nbBufferizedPoints related methods
 *	Description: Number of points in the Keithley buffer
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_nbBufferizedPoints(Tango::Attribute &attr);
	virtual bool is_nbBufferizedPoints_allowed(Tango::AttReqType type);
/**
 *	Attribute data related methods
 *	Description: Keithley bufferised data
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 450000
 */
	virtual void read_data(Tango::Attribute &attr);
	virtual bool is_data_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : KeithleyMultimeters::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();



//	Command related methods
public:
	/**
	 *	Command State related method
	 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
	 *
	 *	@returns Device state
	 */
	virtual Tango::DevState dev_state();
	/**
	 *	Command ReadBufferedData related method
	 *	Description: Command to read back acquired/buffered data
	 *
	 */
	virtual void read_buffered_data();
	virtual bool is_ReadBufferedData_allowed(const CORBA::Any &any);
	/**
	 *	Command WriteRead related method
	 *	Description: Direct access to send (SCPI) low level commands to the instrument
	 *
	 *	@param argin Low level command to send
	 *	@returns Command response (if any)
	 */
	virtual Tango::DevString write_read(Tango::DevString argin);
	virtual bool is_WriteRead_allowed(const CORBA::Any &any);
	/**
	 *	Command Abort related method
	 *	Description: Command to stop/abort acquisition
	 *
	 */
	virtual void abort();
	virtual bool is_Abort_allowed(const CORBA::Any &any);
	/**
	 *	Command Configure related method
	 *	Description: Sends the user configuration defined in property.
	 *
	 */
	virtual void configure();
	virtual bool is_Configure_allowed(const CORBA::Any &any);
	/**
	 *	Command StartAcquisition related method
	 *	Description: Command to start a new acquisition
	 *
	 */
	virtual void start_acquisition();
	virtual bool is_StartAcquisition_allowed(const CORBA::Any &any);


/*----- PROTECTED REGION ID(KeithleyMultimeters::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
protected :	

private :

	KeithleyManager   * m_kmgr;
	//- check properties
  bool m_property_missing;
	//- the received data size
  int m_total_number_of_samples_in_spectrum;
	//- device state/status
  std::string     m_k_status;

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::Additional Method prototypes
};

/*----- PROTECTED REGION ID(KeithleyMultimeters::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	KeithleyMultimeters::Additional Classes Definitions

}	//	End of namespace

#endif   //	KeithleyMultimeters_H
